/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreElementHierarchyVarsRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreElementHierarchyVars extends TableImpl<VCoreElementHierarchyVarsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_core_element_hierarchy_vars</code>
     */
    public static final VCoreElementHierarchyVars V_CORE_ELEMENT_HIERARCHY_VARS = new VCoreElementHierarchyVars();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreElementHierarchyVarsRecord> getRecordType() {
        return VCoreElementHierarchyVarsRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_core_element_hierarchy_vars.key_parent_element</code>.
     */
    public final TableField<VCoreElementHierarchyVarsRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_element_hierarchy_vars.amount</code>.
     */
    public final TableField<VCoreElementHierarchyVarsRecord, Long> AMOUNT = createField(DSL.name("amount"), SQLDataType.BIGINT, this, "");

    private VCoreElementHierarchyVars(Name alias, Table<VCoreElementHierarchyVarsRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreElementHierarchyVars(Name alias, Table<VCoreElementHierarchyVarsRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_element_hierarchy_vars" as  SELECT key_parent_element,
          count(key_parent_element) AS amount
         FROM common_dd.t_core_element_hierarchy
        WHERE (key_element IN ( SELECT t_core_variable.key_variable
                 FROM common_dd.t_core_variable))
        GROUP BY key_parent_element;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_element_hierarchy_vars</code>
     * table reference
     */
    public VCoreElementHierarchyVars(String alias) {
        this(DSL.name(alias), V_CORE_ELEMENT_HIERARCHY_VARS);
    }

    /**
     * Create an aliased <code>common_dd.v_core_element_hierarchy_vars</code>
     * table reference
     */
    public VCoreElementHierarchyVars(Name alias) {
        this(alias, V_CORE_ELEMENT_HIERARCHY_VARS);
    }

    /**
     * Create a <code>common_dd.v_core_element_hierarchy_vars</code> table
     * reference
     */
    public VCoreElementHierarchyVars() {
        this(DSL.name("v_core_element_hierarchy_vars"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreElementHierarchyVars as(String alias) {
        return new VCoreElementHierarchyVars(DSL.name(alias), this);
    }

    @Override
    public VCoreElementHierarchyVars as(Name alias) {
        return new VCoreElementHierarchyVars(alias, this);
    }

    @Override
    public VCoreElementHierarchyVars as(Table<?> alias) {
        return new VCoreElementHierarchyVars(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchyVars rename(String name) {
        return new VCoreElementHierarchyVars(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchyVars rename(Name name) {
        return new VCoreElementHierarchyVars(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchyVars rename(Table<?> name) {
        return new VCoreElementHierarchyVars(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyVars where(Condition condition) {
        return new VCoreElementHierarchyVars(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyVars where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyVars where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyVars where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchyVars where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchyVars where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchyVars where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchyVars where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyVars whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyVars whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
